# Validate Binary Search Tree

> Given the `root` of a binary tree, _determine if it is a valid binary search
> tree_.

A **valid BST** is defined as follows:

- The left subtree of a node contains only nodes with keys **less than** the
  node's key.
- The right subtree of a node contains only nodes with keys **greater than** the
  node's key.
- Both the left and right subtrees must also be binary search trees.

## Example 1

```
                2
        1               3
```

- Input: root = [2, 1, 3]
- Output: true

## Example 2:

```
                5
        1               4
                    3       6
```

- Input: root = [5,1,4,null,null,3,6]
- Output: false
- Explanation: The root node's value is 5 but its right child's value is 4.
